
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>emulsion.agent.views &#8212; EMULSION (Epidemiological Multi-Level Simulation framework)</title>
    <link rel="stylesheet" href="../../../_static/alabaster.css" type="text/css" />
    <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
    <link rel="stylesheet" href="../../../_static/css/custom.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../../_static/doctools.js"></script>
    <script type="text/javascript" src="../../../_static/language_data.js"></script>
    <script async="async" type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.5/latest.js?config=TeX-AMS-MML_HTMLorMML"></script>
    <link rel="shortcut icon" href="../../../_static/STEMAH-favicon.png"/>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" />
   
  <link rel="stylesheet" href="../../../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Source code for emulsion.agent.views</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot;A Python implementation of the EMuLSion framework (Epidemiologic</span>
<span class="sd">MUlti-Level SImulatiONs).</span>

<span class="sd">Classes and functions for entities management.</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="c1"># [HEADER]</span>


<span class="kn">from</span>   <span class="nn">collections</span>               <span class="k">import</span> <span class="n">OrderedDict</span>
<span class="kn">import</span> <span class="nn">numpy</span>                     <span class="k">as</span> <span class="nn">np</span>

<span class="kn">from</span>   <span class="nn">sortedcontainers</span>          <span class="k">import</span> <span class="n">SortedSet</span>

<span class="kn">from</span>   <span class="nn">emulsion.agent.core</span>       <span class="k">import</span> <span class="n">Aggregation</span>
<span class="kn">from</span>   <span class="nn">emulsion.tools.misc</span>       <span class="k">import</span> <span class="n">select_random</span><span class="p">,</span> <span class="n">AGENTS</span>

<span class="c1">#   _____ _                 _   __      ___</span>
<span class="c1">#  / ____(_)               | |  \ \    / (_)</span>
<span class="c1"># | (___  _ _ __ ___  _ __ | | __\ \  / / _  _____      __</span>
<span class="c1">#  \___ \| | &#39;_ ` _ \| &#39;_ \| |/ _ \ \/ / | |/ _ \ \ /\ / /</span>
<span class="c1">#  ____) | | | | | | | |_) | |  __/\  /  | |  __/\ V  V /</span>
<span class="c1"># |_____/|_|_| |_| |_| .__/|_|\___| \/   |_|\___| \_/\_/</span>
<span class="c1">#                    | |</span>
<span class="c1">#                    |_|</span>

<div class="viewcode-block" id="SimpleView"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.SimpleView">[docs]</a><span class="k">class</span> <span class="nc">SimpleView</span><span class="p">(</span><span class="n">Aggregation</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;A SimpleView uses a set to store the underlying</span>
<span class="sd">    units. It is rather aimed at storing AtomAgents. All units are</span>
<span class="sd">    considered in the same state, thus conditions in the state</span>
<span class="sd">    machines are evaluated for the whole compartment, not for</span>
<span class="sd">    individuals.</span>

<span class="sd">    &quot;&quot;&quot;</span>
<div class="viewcode-block" id="SimpleView.__init__"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.SimpleView.__init__">[docs]</a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">**</span><span class="n">others</span><span class="p">):</span>
        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="o">**</span><span class="n">others</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_content</span> <span class="o">=</span> <span class="n">SortedSet</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">stochastic</span> <span class="o">=</span> <span class="kc">True</span></div>

    <span class="k">def</span> <span class="nf">__iter__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_content</span><span class="o">.</span><span class="fm">__iter__</span><span class="p">()</span>

<div class="viewcode-block" id="SimpleView.get_content"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.SimpleView.get_content">[docs]</a>    <span class="k">def</span> <span class="nf">get_content</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Return the units contained in the current unit.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="p">(</span><span class="s1">&#39;agents&#39;</span><span class="p">,</span> <span class="nb">list</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">_content</span><span class="p">))</span></div>

<div class="viewcode-block" id="SimpleView.add"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.SimpleView.add">[docs]</a>    <span class="k">def</span> <span class="nf">add</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">population</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Add the specified population to the current compartment.&quot;&quot;&quot;</span>
        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">population</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_content</span> <span class="o">|=</span> <span class="n">SortedSet</span><span class="p">(</span><span class="n">population</span><span class="p">)</span></div>

<div class="viewcode-block" id="SimpleView.remove"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.SimpleView.remove">[docs]</a>    <span class="k">def</span> <span class="nf">remove</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">population</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Remove the specified population from the current</span>
<span class="sd">        compartment.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">population</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_content</span> <span class="o">-=</span> <span class="n">SortedSet</span><span class="p">(</span><span class="n">population</span><span class="p">)</span></div>

<div class="viewcode-block" id="SimpleView.next_states"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.SimpleView.next_states">[docs]</a>    <span class="k">def</span> <span class="nf">next_states</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">states</span><span class="p">,</span> <span class="n">values</span><span class="p">,</span> <span class="n">populations</span><span class="p">,</span> <span class="n">actions</span><span class="p">,</span> <span class="n">method</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Compute stochastically the population moving from the current</span>
<span class="sd">        compartment to each of the destination states, according to</span>
<span class="sd">        the values interpreted as probabilities. Actions are to be</span>
<span class="sd">        performed when changing state. The population affected by the</span>
<span class="sd">        transitions is stored in the first element of the</span>
<span class="sd">        `populations` parameter, as a tuple: (&#39;agents&#39;,</span>
<span class="sd">        list_of_agents). Several edges can lead to the same state.</span>

<span class="sd">        Return a list of tuples:</span>
<span class="sd">          (state, {&#39;agent&#39;: list of agents, &#39;actions&#39;: list of actions})</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># retrieve the list of agents from the tuple at first position</span>
        <span class="n">origin</span> <span class="o">=</span> <span class="n">populations</span><span class="p">[</span><span class="mi">0</span><span class="p">][</span><span class="n">AGENTS</span><span class="p">]</span>
        <span class="k">if</span> <span class="n">method</span> <span class="o">==</span> <span class="s1">&#39;amount&#39;</span><span class="p">:</span>
            <span class="c1"># length of values is expected to be the number of output edges</span>
            <span class="n">total_value</span> <span class="o">=</span> <span class="nb">sum</span><span class="p">(</span><span class="n">values</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">total_value</span> <span class="o">&gt;</span> <span class="nb">len</span><span class="p">(</span><span class="n">origin</span><span class="p">):</span>
                <span class="c1"># restart with proportions instead</span>
                <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">next_states</span><span class="p">(</span><span class="n">states</span><span class="p">,</span>
                                        <span class="nb">tuple</span><span class="p">(</span><span class="n">v</span> <span class="o">/</span> <span class="n">total_value</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">values</span><span class="p">)</span> <span class="o">+</span> <span class="p">(</span><span class="mi">0</span><span class="p">,),</span>
                                        <span class="n">populations</span><span class="p">,</span> <span class="n">actions</span><span class="p">,</span> <span class="n">method</span><span class="o">=</span><span class="kc">None</span><span class="p">)</span>
            <span class="n">evolution</span> <span class="o">=</span> <span class="p">[</span><span class="nb">int</span><span class="p">(</span><span class="n">v</span><span class="p">)</span> <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">values</span><span class="p">]</span>
            <span class="c1"># print(states, evolution)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="c1"># values is expected to be the number of output edges + 1</span>
            <span class="n">evolution</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">random</span><span class="o">.</span><span class="n">multinomial</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">origin</span><span class="p">),</span> <span class="n">values</span><span class="p">)[:</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>

        <span class="c1">### now select agents corresponding to the amounts</span>
        <span class="c1"># init change list</span>
        <span class="n">changes</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="c1"># track agents already selected</span>
        <span class="n">modified</span> <span class="o">=</span> <span class="n">SortedSet</span><span class="p">()</span>
        <span class="k">for</span> <span class="n">state</span><span class="p">,</span> <span class="n">qty</span><span class="p">,</span> <span class="n">act</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">states</span><span class="p">[:</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="n">evolution</span><span class="p">,</span> <span class="n">actions</span><span class="p">[:</span><span class="o">-</span><span class="mi">1</span><span class="p">]):</span>
            <span class="k">if</span> <span class="n">qty</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
                <span class="c1"># pick up agents randomly (not already chosen) in the</span>
                <span class="c1"># origin group</span>
                <span class="n">moving</span> <span class="o">=</span> <span class="n">select_random</span><span class="p">(</span><span class="n">origin</span><span class="p">,</span> <span class="n">qty</span><span class="p">,</span> <span class="n">exclude</span><span class="o">=</span><span class="n">modified</span><span class="p">)</span>
                <span class="n">modified</span> <span class="o">|=</span> <span class="n">SortedSet</span><span class="p">(</span><span class="n">moving</span><span class="p">)</span>
                <span class="c1"># append this subgroup to the change list</span>
                <span class="n">changes</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="bp">self</span><span class="o">.</span><span class="n">_host</span><span class="o">.</span><span class="n">state_machine</span><span class="o">.</span><span class="n">states</span><span class="p">[</span><span class="n">state</span><span class="p">],</span>
                              <span class="p">{</span><span class="s1">&#39;agents&#39;</span><span class="p">:</span> <span class="n">moving</span><span class="p">,</span> <span class="s1">&#39;actions&#39;</span><span class="p">:</span> <span class="n">act</span><span class="p">}))</span>
        <span class="k">return</span> <span class="n">changes</span></div></div>



<span class="c1">#              _             _   _        __      ___</span>
<span class="c1">#     /\      | |           | | (_)       \ \    / (_)</span>
<span class="c1">#    /  \   __| | __ _ _ __ | |_ ___   ____\ \  / / _  _____      __</span>
<span class="c1">#   / /\ \ / _` |/ _` | &#39;_ \| __| \ \ / / _ \ \/ / | |/ _ \ \ /\ / /</span>
<span class="c1">#  / ____ \ (_| | (_| | |_) | |_| |\ V /  __/\  /  | |  __/\ V  V /</span>
<span class="c1"># /_/    \_\__,_|\__,_| .__/ \__|_| \_/ \___| \/   |_|\___| \_/\_/</span>
<span class="c1">#                     | |</span>
<span class="c1">#                     |_|</span>

<div class="viewcode-block" id="AdaptiveView"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.AdaptiveView">[docs]</a><span class="k">class</span> <span class="nc">AdaptiveView</span><span class="p">(</span><span class="n">SimpleView</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;An AdaptiveView is able to evaluate conditions on individuals</span>
<span class="sd">    (AtomAgents) for state transitions, and to detect changes in its</span>
<span class="sd">    content and automatically report it to the upper level. Each</span>
<span class="sd">    compartment is associated with a particular value of a specific</span>
<span class="sd">    state variable or attribute of the units in its content. At the</span>
<span class="sd">    end of the evolve step, the compartment checks the values of the</span>
<span class="sd">    units in its content and reports units where changes occured.</span>

<span class="sd">    &quot;&quot;&quot;</span>
<div class="viewcode-block" id="AdaptiveView.__init__"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.AdaptiveView.__init__">[docs]</a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">observables</span><span class="o">=</span><span class="p">(</span><span class="kc">None</span><span class="p">,),</span> <span class="n">values</span><span class="o">=</span><span class="p">(</span><span class="kc">None</span><span class="p">,),</span> <span class="o">**</span><span class="n">others</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Specify the state variables or attributes associated with</span>
<span class="sd">        this compartment (``observables``) and the expected values.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="o">**</span><span class="n">others</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">observables</span> <span class="o">=</span> <span class="n">observables</span>
        <span class="k">for</span> <span class="p">(</span><span class="n">observable</span><span class="p">,</span> <span class="n">value</span><span class="p">)</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">observables</span><span class="p">,</span> <span class="n">values</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="p">[</span><span class="n">observable</span><span class="p">]</span> <span class="o">=</span> <span class="n">value</span></div>


<div class="viewcode-block" id="AdaptiveView.evaluate_condition"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.AdaptiveView.evaluate_condition">[docs]</a>    <span class="k">def</span> <span class="nf">evaluate_condition</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">condition</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Return the population of the compartment if the condition</span>
<span class="sd">        is fulfilled, 0 otherwise.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="n">callable</span><span class="p">(</span><span class="n">condition</span><span class="p">):</span>
            <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_content</span><span class="p">()</span> <span class="k">if</span> <span class="n">condition</span> <span class="k">else</span> <span class="p">()</span>
        <span class="n">result</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="nb">filter</span><span class="p">(</span><span class="n">condition</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">_content</span><span class="p">))</span>
        <span class="k">return</span> <span class="p">(</span><span class="s1">&#39;agents&#39;</span><span class="p">,</span> <span class="n">result</span><span class="p">)</span> <span class="k">if</span> <span class="n">result</span> <span class="k">else</span> <span class="p">()</span></div>

<div class="viewcode-block" id="AdaptiveView.next_states"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.AdaptiveView.next_states">[docs]</a>    <span class="k">def</span> <span class="nf">next_states</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">states</span><span class="p">,</span> <span class="n">values</span><span class="p">,</span> <span class="n">populations</span><span class="p">,</span> <span class="n">actions</span><span class="p">,</span> <span class="n">method</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Compute stochastically the population moving from each population</span>
<span class="sd">        (tuples (&#39;agents&#39;: list_of_agents)) in the `populations`</span>
<span class="sd">        parameter, to each of the possible destination states,</span>
<span class="sd">        according to each of the values interpreted as</span>
<span class="sd">        probabilities. Actions are to be performed when changing</span>
<span class="sd">        state. Several edges can lead to the same state.</span>

<span class="sd">        Return a list of tuples:</span>
<span class="sd">          (state, {&#39;agent&#39;: list of agents, &#39;actions&#39;: list of actions})</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">populations</span><span class="p">)</span> <span class="o">==</span> <span class="mi">1</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">method</span> <span class="o">==</span> <span class="s1">&#39;amount&#39;</span><span class="p">:</span>
                <span class="c1"># length of values is expected to be the number of output edges</span>
                <span class="n">total_value</span> <span class="o">=</span> <span class="nb">sum</span><span class="p">(</span><span class="n">values</span><span class="p">)</span>
                <span class="k">if</span> <span class="n">total_value</span> <span class="o">&gt;</span> <span class="nb">len</span><span class="p">(</span><span class="n">populations</span><span class="p">[</span><span class="mi">0</span><span class="p">][</span><span class="n">AGENTS</span><span class="p">]):</span>
                    <span class="c1"># restart with proportions instead</span>
                    <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">next_states</span><span class="p">(</span><span class="n">states</span><span class="p">,</span>
                                            <span class="nb">tuple</span><span class="p">(</span><span class="n">v</span> <span class="o">/</span> <span class="n">total_value</span>
                                                  <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">values</span><span class="p">)</span> <span class="o">+</span> <span class="p">(</span><span class="mi">0</span><span class="p">,),</span>
                                            <span class="n">populations</span><span class="p">,</span> <span class="n">actions</span><span class="p">,</span> <span class="n">method</span><span class="o">=</span><span class="kc">None</span><span class="p">)</span>
                <span class="n">values</span> <span class="o">=</span> <span class="n">values</span> <span class="o">+</span> <span class="p">(</span><span class="n">total_value</span><span class="p">,)</span>
            <span class="n">populations</span> <span class="o">*=</span> <span class="nb">len</span><span class="p">(</span><span class="n">states</span><span class="p">)</span><span class="o">-</span><span class="mi">1</span>
        <span class="c1"># init change list</span>
        <span class="n">changes</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="c1"># track agents already selected</span>
        <span class="n">modified</span> <span class="o">=</span> <span class="n">SortedSet</span><span class="p">()</span>
        <span class="k">for</span> <span class="n">state</span><span class="p">,</span> <span class="n">value</span><span class="p">,</span> <span class="n">population</span><span class="p">,</span> <span class="n">act</span>\
          <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">states</span><span class="p">[:</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="n">values</span><span class="p">[:</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="n">populations</span><span class="p">,</span> <span class="n">actions</span><span class="p">[:</span><span class="o">-</span><span class="mi">1</span><span class="p">]):</span>
            <span class="k">if</span> <span class="n">method</span> <span class="o">==</span> <span class="s1">&#39;amount&#39;</span><span class="p">:</span>
                <span class="n">evolution</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">value</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">evolution</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">random</span><span class="o">.</span><span class="n">binomial</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">population</span><span class="p">[</span><span class="n">AGENTS</span><span class="p">]),</span> <span class="n">value</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">evolution</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
                <span class="c1">### now select agents corresponding to the amounts</span>
                <span class="c1"># pick up agents randomly (not already chosen) in the</span>
                <span class="c1"># origin group</span>
                <span class="n">moving</span> <span class="o">=</span> <span class="n">select_random</span><span class="p">(</span><span class="n">population</span><span class="p">[</span><span class="n">AGENTS</span><span class="p">],</span>
                                       <span class="n">evolution</span><span class="p">,</span> <span class="n">exclude</span><span class="o">=</span><span class="n">modified</span><span class="p">)</span>
                <span class="n">modified</span> <span class="o">|=</span> <span class="n">SortedSet</span><span class="p">(</span><span class="n">moving</span><span class="p">)</span>
                <span class="c1"># append this subgroup to the change list</span>
                <span class="n">changes</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="bp">self</span><span class="o">.</span><span class="n">_host</span><span class="o">.</span><span class="n">state_machine</span><span class="o">.</span><span class="n">states</span><span class="p">[</span><span class="n">state</span><span class="p">],</span>
                              <span class="p">{</span><span class="s1">&#39;agents&#39;</span><span class="p">:</span> <span class="n">moving</span><span class="p">,</span> <span class="s1">&#39;actions&#39;</span><span class="p">:</span> <span class="n">act</span><span class="p">}))</span>
        <span class="k">return</span> <span class="n">changes</span></div>


<div class="viewcode-block" id="AdaptiveView.evolve"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.AdaptiveView.evolve">[docs]</a>    <span class="k">def</span> <span class="nf">evolve</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">machine</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;After the ordinary ``evolve`` step, check units which have</span>
<span class="sd">        changed their value(s) of the compartment-specific</span>
<span class="sd">        observable(s). The corresponding units are reported to the</span>
<span class="sd">        upper level.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="n">evolve</span><span class="p">(</span><span class="n">machine</span><span class="o">=</span><span class="n">machine</span><span class="p">)</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">_is_active</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">check_consistency</span><span class="p">()</span></div>

<div class="viewcode-block" id="AdaptiveView.check_consistency"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.AdaptiveView.check_consistency">[docs]</a>    <span class="k">def</span> <span class="nf">check_consistency</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Check the value of the observables of the current</span>
<span class="sd">        compartment. Units which do not have the expected values are</span>
<span class="sd">        notified to the upper level.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># intruders = [unit for unit in self</span>
        <span class="c1">#              if any(unit.get_information(observable)\</span>
        <span class="c1">#                       != self.statevars[observable]</span>
        <span class="c1">#                     for observable in self.statevars.observables)]</span>
        <span class="n">intruders</span> <span class="o">=</span> <span class="n">SortedSet</span><span class="p">()</span>
        <span class="k">for</span> <span class="n">unit</span> <span class="ow">in</span> <span class="bp">self</span><span class="p">:</span>
            <span class="k">for</span> <span class="n">observable</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">observables</span><span class="p">:</span>
                <span class="k">if</span> <span class="n">unit</span><span class="o">.</span><span class="n">get_information</span><span class="p">(</span><span class="n">observable</span><span class="p">)</span> <span class="o">!=</span> <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="p">[</span><span class="n">observable</span><span class="p">]:</span>
                    <span class="n">intruders</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">unit</span><span class="p">)</span>
                    <span class="k">break</span>
        <span class="k">if</span> <span class="n">intruders</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">_host</span><span class="o">.</span><span class="n">notify_changed_units</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">intruders</span><span class="p">)</span></div>

<div class="viewcode-block" id="AdaptiveView.clone"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.AdaptiveView.clone">[docs]</a>    <span class="k">def</span> <span class="nf">clone</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">**</span><span class="n">others</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Make a copy of the current compartment with the specified</span>
<span class="sd">        observable/value settings. The new content is empty.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># new_comp = copy.copy(self)</span>
        <span class="c1"># new_comp._content = SortedSet()</span>
        <span class="c1"># new_comp.statevars = StateVarDict(self.statevars)</span>
        <span class="n">new_comp</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="vm">__class__</span><span class="o">.</span><span class="n">from_dict</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="p">)</span>
        <span class="n">new_comp</span><span class="o">.</span><span class="n">model</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">model</span>
        <span class="n">new_comp</span><span class="o">.</span><span class="n">_content</span> <span class="o">=</span> <span class="n">SortedSet</span><span class="p">()</span>
        <span class="n">new_comp</span><span class="o">.</span><span class="n">_host</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">_host</span>
        <span class="n">new_comp</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">update</span><span class="p">(</span><span class="o">**</span><span class="n">others</span><span class="p">)</span>
        <span class="c1"># new_comp.statevars.step = self.statevars.step</span>
        <span class="n">new_comp</span><span class="o">.</span><span class="n">recursive</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">recursive</span>
<span class="c1">#        new_comp.set_information(observable, value)</span>
        <span class="k">return</span> <span class="n">new_comp</span></div></div>



<span class="c1">#   _____ _                   _                      ___      ___</span>
<span class="c1">#  / ____| |                 | |                    | \ \    / (_)</span>
<span class="c1"># | (___ | |_ _ __ _   _  ___| |_ _   _ _ __ ___  __| |\ \  / / _  _____      __</span>
<span class="c1">#  \___ \| __| &#39;__| | | |/ __| __| | | | &#39;__/ _ \/ _` | \ \/ / | |/ _ \ \ /\ / /</span>
<span class="c1">#  ____) | |_| |  | |_| | (__| |_| |_| | | |  __/ (_| |  \  /  | |  __/\ V  V /</span>
<span class="c1"># |_____/ \__|_|   \__,_|\___|\__|\__,_|_|  \___|\__,_|   \/   |_|\___| \_/\_/</span>


<div class="viewcode-block" id="StructuredView"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.StructuredView">[docs]</a><span class="k">class</span> <span class="nc">StructuredView</span><span class="p">(</span><span class="n">Aggregation</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;A StructuredView uses ad dict list to store the underlying</span>
<span class="sd">    units. It is rather aimed at storing other compartiments.</span>

<span class="sd">    &quot;&quot;&quot;</span>
<div class="viewcode-block" id="StructuredView.__init__"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.StructuredView.__init__">[docs]</a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">keep_history</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="o">**</span><span class="n">others</span><span class="p">):</span>
        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="o">**</span><span class="n">others</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">keep_history</span> <span class="o">=</span> <span class="n">keep_history</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">new_population</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_content</span> <span class="o">=</span> <span class="n">OrderedDict</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_notifications</span> <span class="o">=</span> <span class="p">{}</span></div>

    <span class="k">def</span> <span class="nf">__iter__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="c1"># use a copy of values to allow for modifications during the time step</span>
        <span class="k">return</span> <span class="nb">list</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">_content</span><span class="o">.</span><span class="n">values</span><span class="p">())</span><span class="o">.</span><span class="fm">__iter__</span><span class="p">()</span>

    <span class="k">def</span> <span class="nf">__getitem__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">):</span>
        <span class="k">if</span> <span class="n">name</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">_content</span><span class="p">:</span> <span class="c1"># DEBUG: should not happen !</span>
            <span class="nb">print</span><span class="p">(</span><span class="n">name</span><span class="p">)</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">_content</span><span class="p">[</span><span class="n">name</span><span class="p">]</span>

<div class="viewcode-block" id="StructuredView.get_content"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.StructuredView.get_content">[docs]</a>    <span class="k">def</span> <span class="nf">get_content</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Return the agents contained in the current view.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;WARNING, should not enter here !!!&#39;</span><span class="p">)</span>
        <span class="k">return</span> <span class="p">(</span><span class="s1">&#39;agents&#39;</span><span class="p">,</span> <span class="nb">list</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">_content</span><span class="o">.</span><span class="n">values</span><span class="p">()))</span></div>

<div class="viewcode-block" id="StructuredView.add"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.StructuredView.add">[docs]</a>    <span class="k">def</span> <span class="nf">add</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">population</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Add the specified population to the current</span>
<span class="sd">        compartment. The population is expected to be a dictionary</span>
<span class="sd">        with names as keys and compartments as values.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">for</span> <span class="n">key</span><span class="p">,</span> <span class="n">pop</span> <span class="ow">in</span> <span class="n">population</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="k">if</span> <span class="n">key</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">_content</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">_content</span><span class="p">[</span><span class="n">key</span><span class="p">]</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">pop</span><span class="o">.</span><span class="n">_content</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">_content</span><span class="p">[</span><span class="n">key</span><span class="p">]</span> <span class="o">=</span> <span class="n">pop</span></div>

<div class="viewcode-block" id="StructuredView.remove"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.StructuredView.remove">[docs]</a>    <span class="k">def</span> <span class="nf">remove</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">population</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Remove the specified population from the current</span>
<span class="sd">        compartment.  The population is expected to be a dictionary</span>
<span class="sd">        with names as keys and compartments as values.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">for</span> <span class="n">key</span><span class="p">,</span> <span class="n">pop</span> <span class="ow">in</span> <span class="n">population</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="k">if</span> <span class="n">key</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">_content</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">_content</span><span class="p">[</span><span class="n">key</span><span class="p">]</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">pop</span><span class="o">.</span><span class="n">_content</span><span class="p">)</span></div>

<div class="viewcode-block" id="StructuredView.notify_changed_units"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.StructuredView.notify_changed_units">[docs]</a>    <span class="k">def</span> <span class="nf">notify_changed_units</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">source_compartment</span><span class="p">,</span> <span class="n">units</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Receive a change notification concerning several units</span>
<span class="sd">        which cannot be stored anymore in the source compartment.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="n">source_compartment</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">_notifications</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">_notifications</span><span class="p">[</span><span class="n">source_compartment</span><span class="p">]</span> <span class="o">|=</span> <span class="n">units</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">_notifications</span><span class="p">[</span><span class="n">source_compartment</span><span class="p">]</span> <span class="o">=</span> <span class="n">SortedSet</span><span class="p">(</span><span class="n">units</span><span class="p">)</span></div>

<div class="viewcode-block" id="StructuredView.handle_notifications"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.StructuredView.handle_notifications">[docs]</a>    <span class="k">def</span> <span class="nf">handle_notifications</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Handle all notifications received during the time step.&quot;&quot;&quot;</span>
        <span class="k">for</span> <span class="n">source_compartment</span><span class="p">,</span> <span class="n">units</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">_notifications</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="n">source_observables</span> <span class="o">=</span> <span class="n">source_compartment</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">observables</span>
            <span class="n">new_pop</span> <span class="o">=</span> <span class="p">{}</span>
 <span class="c1">#           pop_values = {}</span>
            <span class="k">for</span> <span class="n">unit</span> <span class="ow">in</span> <span class="n">units</span><span class="p">:</span>
                <span class="n">key</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">unit</span><span class="o">.</span><span class="n">get_information</span><span class="p">(</span><span class="n">k</span><span class="p">)</span> <span class="k">for</span> <span class="n">k</span> <span class="ow">in</span> <span class="n">source_observables</span><span class="p">)</span>
                <span class="k">if</span> <span class="n">key</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">new_pop</span><span class="p">:</span>
                    <span class="n">new_pop</span><span class="p">[</span><span class="n">key</span><span class="p">]</span> <span class="o">=</span> <span class="p">[</span><span class="n">unit</span><span class="p">]</span>
<span class="c1">#                    pop_values[key] = unit.get_information(source_observable)</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="n">new_pop</span><span class="p">[</span><span class="n">key</span><span class="p">]</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">unit</span><span class="p">)</span>
            <span class="k">for</span> <span class="n">key</span><span class="p">,</span> <span class="n">unit</span> <span class="ow">in</span> <span class="n">new_pop</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
                <span class="c1"># print(source_observables, key)</span>
                <span class="n">new_comp</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_or_build</span><span class="p">(</span><span class="n">key</span><span class="p">,</span> <span class="n">source</span><span class="o">=</span><span class="n">source_compartment</span><span class="p">)</span>
<span class="c1">#                print(&#39;Moving to:&#39;, new_comp, &#39;\n\t&#39;, [u._agid for u in unit])</span>
                <span class="n">source_compartment</span><span class="o">.</span><span class="n">move_to</span><span class="p">(</span><span class="n">new_comp</span><span class="p">,</span> <span class="n">agents</span><span class="o">=</span><span class="n">unit</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_notifications</span><span class="o">.</span><span class="n">clear</span><span class="p">()</span></div>

<div class="viewcode-block" id="StructuredView.get_or_build"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.StructuredView.get_or_build">[docs]</a>    <span class="k">def</span> <span class="nf">get_or_build</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">key</span><span class="p">,</span> <span class="n">source</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Return the compartment with the specified key if any, or</span>
<span class="sd">        build one by cloning the source if not found.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="n">key</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">_content</span><span class="p">:</span>
            <span class="n">key_infos</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">(</span><span class="nb">zip</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">keys</span><span class="p">,</span> <span class="n">key</span><span class="p">))</span>
            <span class="c1"># print(&#39;Adding new comp:&#39;, key, key_infos)</span>
            <span class="n">new_compart</span> <span class="o">=</span> <span class="n">source</span><span class="o">.</span><span class="n">clone</span><span class="p">(</span><span class="n">host</span><span class="o">=</span><span class="bp">self</span><span class="p">,</span> <span class="o">**</span><span class="n">key_infos</span><span class="p">)</span>
            <span class="n">new_compart</span><span class="o">.</span><span class="n">keys</span> <span class="o">=</span> <span class="n">key</span>
            <span class="c1"># if any key for compart is a state marked &quot;autoremove&quot;,</span>
            <span class="c1"># then the whole compart is marked &quot;autoremove&quot;</span>
            <span class="n">new_compart</span><span class="o">.</span><span class="n">autoremove</span> <span class="o">=</span> <span class="nb">any</span><span class="p">(</span><span class="nb">hasattr</span><span class="p">(</span><span class="n">value</span><span class="p">,</span> <span class="s1">&#39;state_machine&#39;</span><span class="p">)</span> <span class="ow">and</span>\
                                  <span class="n">value</span><span class="o">.</span><span class="n">state_machine</span><span class="o">.</span><span class="n">get_property</span><span class="p">(</span><span class="n">value</span><span class="o">.</span><span class="n">name</span><span class="p">,</span> <span class="s1">&#39;autoremove&#39;</span><span class="p">)</span>
                                  <span class="k">for</span> <span class="n">value</span> <span class="ow">in</span> <span class="n">key</span><span class="p">)</span>
            <span class="c1"># print(new_compart, new_compart.autoremove)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">add</span><span class="p">({</span><span class="n">key</span><span class="p">:</span> <span class="n">new_compart</span><span class="p">})</span>
        <span class="k">return</span> <span class="bp">self</span><span class="p">[</span><span class="n">key</span><span class="p">]</span></div>

<div class="viewcode-block" id="StructuredView.evolve"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.StructuredView.evolve">[docs]</a>    <span class="k">def</span> <span class="nf">evolve</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">machine</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="n">evolve</span><span class="p">(</span><span class="n">machine</span><span class="o">=</span><span class="n">machine</span><span class="p">)</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">_is_active</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">handle_notifications</span><span class="p">()</span></div></div>




<div class="viewcode-block" id="StructuredViewWithCounts"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.StructuredViewWithCounts">[docs]</a><span class="k">class</span> <span class="nc">StructuredViewWithCounts</span><span class="p">(</span><span class="n">StructuredView</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Same as StructuredView, plus the capability of handling counts for</span>
<span class="sd">    key values.</span>

<span class="sd">    &quot;&quot;&quot;</span>
<div class="viewcode-block" id="StructuredViewWithCounts.__init__"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.StructuredViewWithCounts.__init__">[docs]</a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">allowed_values</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="o">**</span><span class="n">others</span><span class="p">):</span>
        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="o">**</span><span class="n">others</span><span class="p">)</span>
        <span class="c1"># if allowed_values:</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">allowed_values</span> <span class="o">=</span> <span class="n">allowed_values</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">init_counts</span><span class="p">()</span></div>

<div class="viewcode-block" id="StructuredViewWithCounts.init_counts"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.StructuredViewWithCounts.init_counts">[docs]</a>    <span class="k">def</span> <span class="nf">init_counts</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">index</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Initialize the counts.&quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">counts</span> <span class="o">=</span> <span class="p">{}</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">allowed_values</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">counts</span> <span class="o">=</span> <span class="p">{</span><span class="n">value</span><span class="p">:</span> <span class="p">[]</span> <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">keep_history</span> <span class="k">else</span> <span class="mi">0</span>
                           <span class="k">for</span> <span class="n">value</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">allowed_values</span><span class="p">}</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">counts</span><span class="p">[</span><span class="s1">&#39;step&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="p">[]</span> <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">keep_history</span> <span class="k">else</span> <span class="mi">0</span></div>

<div class="viewcode-block" id="StructuredViewWithCounts.update_counts"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.StructuredViewWithCounts.update_counts">[docs]</a>    <span class="k">def</span> <span class="nf">update_counts</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">index</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Update the counts.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">allowed_values</span><span class="p">:</span>
            <span class="n">total</span> <span class="o">=</span> <span class="p">{</span><span class="n">value</span><span class="p">:</span> <span class="mi">0</span> <span class="k">for</span> <span class="n">value</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">allowed_values</span><span class="p">}</span>
            <span class="k">for</span> <span class="p">(</span><span class="n">key</span><span class="p">,</span> <span class="n">unit</span><span class="p">)</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">_content</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
                <span class="k">if</span> <span class="n">key</span><span class="p">[</span><span class="n">index</span><span class="p">]</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="ow">and</span> <span class="n">key</span><span class="p">[</span><span class="n">index</span><span class="p">]</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">allowed_values</span><span class="p">:</span>
                    <span class="n">total</span><span class="p">[</span><span class="n">key</span><span class="p">[</span><span class="n">index</span><span class="p">]]</span> <span class="o">+=</span> <span class="n">unit</span><span class="o">.</span><span class="n">get_information</span><span class="p">(</span><span class="s1">&#39;population&#39;</span><span class="p">)</span>
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">keep_history</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">counts</span><span class="p">[</span><span class="s1">&#39;step&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">step</span><span class="p">)</span>
                <span class="k">for</span> <span class="n">value</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">allowed_values</span><span class="p">:</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">counts</span><span class="p">[</span><span class="n">value</span><span class="p">]</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">total</span><span class="p">[</span><span class="n">value</span><span class="p">])</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">counts</span><span class="p">[</span><span class="s1">&#39;step&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">step</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">counts</span><span class="o">.</span><span class="n">update</span><span class="p">(</span><span class="n">total</span><span class="p">)</span></div>

    <span class="k">def</span> <span class="nf">__contains__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">keys</span><span class="p">):</span>
        <span class="k">return</span> <span class="n">keys</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">_content</span>

<div class="viewcode-block" id="StructuredViewWithCounts.evolve"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.StructuredViewWithCounts.evolve">[docs]</a>    <span class="k">def</span> <span class="nf">evolve</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="n">evolve</span><span class="p">()</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">_is_active</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">update_counts</span><span class="p">()</span></div></div>




<span class="c1">#                _        _____ _                   _                      _</span>
<span class="c1">#     /\        | |      / ____| |                 | |                    | |</span>
<span class="c1">#    /  \  _   _| |_ ___| (___ | |_ _ __ _   _  ___| |_ _   _ _ __ ___  __| |</span>
<span class="c1">#   / /\ \| | | | __/ _ \\___ \| __| &#39;__| | | |/ __| __| | | | &#39;__/ _ \/ _` |</span>
<span class="c1">#  / ____ \ |_| | || (_) |___) | |_| |  | |_| | (__| |_| |_| | | |  __/ (_| |</span>
<span class="c1"># /_/    \_\__,_|\__\___/_____/ \__|_|   \__,_|\___|\__|\__,_|_|  \___|\__,_|</span>
<span class="c1"># __      ___</span>
<span class="c1"># \ \    / (_)</span>
<span class="c1">#  \ \  / / _  _____      __</span>
<span class="c1">#   \ \/ / | |/ _ \ \ /\ / /</span>
<span class="c1">#    \  /  | |  __/\ V  V /</span>
<span class="c1">#     \/   |_|\___| \_/\_/</span>


<div class="viewcode-block" id="AutoStructuredView"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.AutoStructuredView">[docs]</a><span class="k">class</span> <span class="nc">AutoStructuredView</span><span class="p">(</span><span class="n">StructuredView</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;An AutoStructuredView stores agents in an OrderedDict, using a</span>
<span class="sd">    specific statevar as key.</span>

<span class="sd">    &quot;&quot;&quot;</span>
<div class="viewcode-block" id="AutoStructuredView.__init__"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.AutoStructuredView.__init__">[docs]</a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">key_variable</span><span class="p">,</span> <span class="o">**</span><span class="n">others</span><span class="p">):</span> <span class="c1"># =None removed after Sandie&#39;s wise suggestion</span>
        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="o">**</span><span class="n">others</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">key_variable</span> <span class="o">=</span> <span class="n">key_variable</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">current_key</span> <span class="o">=</span> <span class="mi">0</span>    <span class="c1"># auto-increment ID if none specified</span></div>


<div class="viewcode-block" id="AutoStructuredView.add"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.AutoStructuredView.add">[docs]</a>    <span class="k">def</span> <span class="nf">add</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">population</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Add the specified population (SortedSet or list) to the</span>
<span class="sd">        current view.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">for</span> <span class="n">agent</span> <span class="ow">in</span> <span class="n">population</span><span class="p">:</span>
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">key_variable</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">agent</span><span class="o">.</span><span class="n">statevars</span><span class="p">:</span>
                <span class="n">agent</span><span class="o">.</span><span class="n">statevars</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">key_variable</span><span class="p">]</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">current_key</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">current_key</span> <span class="o">+=</span> <span class="mi">1</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">current_key</span> <span class="o">=</span> <span class="nb">max</span><span class="p">(</span><span class="mi">1</span> <span class="o">+</span> <span class="n">agent</span><span class="o">.</span><span class="n">statevars</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">key_variable</span><span class="p">],</span>
                                       <span class="bp">self</span><span class="o">.</span><span class="n">current_key</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">_content</span><span class="p">[</span><span class="n">agent</span><span class="o">.</span><span class="n">statevars</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">key_variable</span><span class="p">]]</span> <span class="o">=</span> <span class="n">agent</span></div>

<div class="viewcode-block" id="AutoStructuredView.remove"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.views.AutoStructuredView.remove">[docs]</a>    <span class="k">def</span> <span class="nf">remove</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">population</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Remove the specified population from the current view. The</span>
<span class="sd">        population is expected to be a SortedSet or list.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">for</span> <span class="n">agent</span> <span class="ow">in</span> <span class="n">population</span><span class="p">:</span>
            <span class="n">key</span> <span class="o">=</span> <span class="n">agent</span><span class="o">.</span><span class="n">statevars</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">key_variable</span><span class="p">]</span>
            <span class="k">if</span> <span class="n">key</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">_content</span><span class="p">:</span>
                <span class="k">del</span> <span class="bp">self</span><span class="o">.</span><span class="n">_content</span><span class="p">[</span><span class="n">key</span><span class="p">]</span></div></div>
</pre></div>

          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../../index.html">EMULSION</a></h1>



<p class="blurb">Epidemiological Multi-Level Simulation Framework</p>






<h3>Navigation</h3>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Information.html">1. Information</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Install.html">2. Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Getting_started.html">3. Getting started with EMULSION</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Modelling_principles.html">4. Modelling principles</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Modelling_language_basics.html">5. Modelling language (basics)</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Modelling_language_advanced.html">6. Modelling language (advanced)</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Feature_examples.html">7. Feature examples</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Release_notes.html">8. Release notes</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/License.html">9. License</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../emulsion_for_modellers.html">10. High-level functions for model designers</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../emulsion.html">11. emulsion package</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../../index.html">Documentation overview</a><ul>
  <li><a href="../../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2016, INRAE and Univ. Lille.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 1.8.5</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.10</a>
      
    </div>

    

    
  </body>
</html>